<template>
  <v-row>
    <v-col :cols="12" justify="center">
      <v-card>
        <v-row>
          <v-col :cols="4" :sm="4" :lg="3">
            <v-container style="text-align: center">
              <img :src="deviceInfo.image" width="70%" />
            </v-container>
          </v-col>
          <v-col :cols="8" :sm="8" :lg="3">
            <v-card-title>
              <span>{{ deviceInfo.model_name }}</span>
            </v-card-title>

            <v-card-text>
              <div class="mb-3 device-info-text">
                MODEL NUMBER : {{ deviceInfo.model_number }} <br />
                IMEI : {{ deviceInfo.imei }} <br />
                SERIAL NUMBER : {{ deviceInfo.serial_number }}<br />
                OS : {{ deviceInfo.os }} <br />
                RAM : {{ deviceInfo.ram }}<br />
              </div>
            </v-card-text>
          </v-col>
        </v-row>
      </v-card>
    </v-col>
    <!-- logcat table -->
    <v-col :cols="12">
      <v-card>
        <v-card-title>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
        </v-card-title>
        <v-data-table
          :headers="headers"
          :items="logdata"
          :items-per-page="150"
          :search="search"
          :footer-props="{
            itemsPerPageOptions: [150, 300, 500, 1000, -1]
          }"
          multi-sort
          dense
        >
          <v-data-footer :items-per-page-options="[150, 300, 500, 1000]" />
        </v-data-table>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import logcat from "@/service/logcat";

export default {
  data() {
    return {
      polling: null,
      search: "",
      logs: [],
      headers: [
        { text: "Datetime", value: "datetime" },
        { text: "Caller", value: "caller", sortable: false },
        { text: "PID", value: "pid", sortable: false },
        { text: "TID", value: "tid", sortable: false },
        { text: "Payload", value: "payload" }
      ],
      since: 0
    };
  },
  computed: {
    deviceInfo() {
      return {
        image: "/devices/google-pixel-3-xl.svg",
        model_name: "Google Pixel 3 XL",
        model_number: "G013C",
        serial_number: "G123456789",
        os: "Android 9.0",
        imei: "01234567890123456789",
        ram: "4 GB LPDDR4X SDRAM"
      };
    },
    logdata() {
      return this.logs.map(_ => {
        _.data.datetime = _.create_at;
        return _.data;
      });
    }
  },
  created() {
    this.getLogPeriodically();
  },
  methods: {
    getLog(log_group = 1, since = 0) {
      let log = [];
      logcat.parseLogcat(log_group, since).then(res => {
        for (log of res.data) {
          try {
            this.logs.push(log);
            if (this.since < log.create_at) this.since = log.create_at;
          } catch (error) {
            console.log(error);
          }
        }
        console.log(this.logs); // for debug
      });

      console.log(`since : ${this.since}`);
    },
    getLogPeriodically() {
      this.polling = setInterval(() => {
        this.getLog(1, this.since);
      }, 10000); // 10s interval
    }
  },
  beforeDestory() {
    window.clearInterval(this.polling);
  }
};
</script>

<style lang="sass" scoped>
.device-info-text
  font-size: 15px
  letter-spacing: 0px
  line-height: 35px
</style>
